#!/usr/bin/perl
# 
# library - form 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.08;
	require 'sbtext.pl';
	# == sbform.pl ܻ for sbform_read ============================================
	# ɬܥХѿ : %gIn,@gIn
	# ----------------------------------------------------------------------------------
	# GET/POST                             => Хѿ %gIn ˳Ǽ
	# POST (enctype="multipart/form-data") => Хѿ @gIn ѥ᡼Ǽ
	# $ENV{PATH_INFO}                      => Хѿ $gIn{'path'} ˳Ǽ 
	# ----------------------------------------------------------------------------------
}

sub sbform_read { # ϥեǡɹ
	local ($fmin,@fmin,%fmin) = (); # ѥ᡼
	&clform_ReadParse(*fmin);
	while (my($fmkey,$fmval) = each(%fmin)) {
		$gIn{$fmkey} = $fmval;
	}
	$gIn{'path'} = $ENV{PATH_INFO};
	@gIn = @fmin;
	undef *fmin;
	undef *in;
	return();
}

sub clform_ReadParse { # from cgi-lib.pl 2.18 / Copyright (c) 1993-1999 Steven E. Brenner
	my ($perlwarn);
	$perlwarn = $^W;
	$^W = 0;
	local (*in) = shift if @_; # CGI input
	local (
		*incfn, # Client's filename (may not be provided)
		*inct,  # Client's content-type (may not be provided)
		*insfn  # Server's filename (for spooled files)
	) = @_;
	my $aMaxData    = ($gEnv{'basic'}{'max_data'}) ? $gEnv{'basic'}{'max_data'} : 102400; # maximum bytes to accept via POST - 2^17
	my $aWriteFiles = 0;        # directory to which to write files, or 0 if files should not be written
	my $aFilePre    = 'clform'; # Prefix of file names, in directory above
	my $aBufSize    = 8192;     # default buffer size when reading multipart
	my $aMaxBound   = 100;      # maximum boundary length to be encounterd
	my ($len, $type, $meth, $errflag, $cmdflag, $got, $name);
	binmode(STDIN);   # we need these for DOS-based systems
	binmode(STDOUT);  # and they shouldn't hurt anything else 
	binmode(STDERR);
	# Get several useful env variables
	$type = $ENV{'CONTENT_TYPE'};
	$len  = $ENV{'CONTENT_LENGTH'};
	$meth = $ENV{'REQUEST_METHOD'};
	if ($len > $aMaxData) { 
		&clform_CgiDie("clform: Request to receive too much data: $len bytes\n");
	}
	if (!defined $meth || $meth eq '' || $meth eq 'GET' || $meth eq 'HEAD' || $type =~ m/^application\/x-www-form-urlencoded(;|$)/) {
		my ($key, $val, $i, $check_dec);
		if (!defined $meth || $meth eq '') {
			$in = $ENV{'QUERY_STRING'};
			$cmdflag = 1;  # also use command-line options
		} elsif($meth eq 'GET' || $meth eq 'HEAD') {
			$in = $ENV{'QUERY_STRING'};
		} elsif ($meth eq 'POST') {
			if (($got = read(STDIN, $in, $len) != $len)) {
				$errflag = "Short Read: wanted $len, got $got\n";
			}
		} else {
			&clform_CgiDie("clform: Unknown request method: $meth\n");
		}
		$check_dec = (index($in,'mode=bm') > -1) ? 0 : 1;
		@in = split(/[&;]/,$in); 
		push(@in, @ARGV) if $cmdflag; # add command-line parameters
		foreach $i (0 .. $#in) {
			$in[$i] =~ s/\+/ /g;
			($key, $val) = split(/=/,$in[$i],2);
			$key = &sbtxt_uridec($key) if ($check_dec);
			$val = &sbtxt_uridec($val) if ($check_dec);
			next if ($key eq 'mode' and $val eq 'regi');
			$in{$key} .= "\0" if (defined($in{$key}));
			$in{$key} .= $val;
		}
	} elsif ($type =~ m/^multipart\/form-data/) {
		$errflag = !(eval <<'END_MULTIPART');
		my ($buf, $boundary, $head, @heads, $cd, $ct, $fname, $ctype, $blen);
		my ($bpos, $lpos, $left, $amt, $fn, $ser);
		my ($bufsize, $maxbound, $writefiles) = ($aBufSize, $aMaxBound, $aWriteFiles);
		$buf = ''; 
		($boundary) = $type =~ /boundary="([^"]+)"/; #";   # find boundary
		($boundary) = $type =~ /boundary=(\S+)/ unless $boundary;
		&clform_CgiDie ("Boundary not provided: probably a bug in your server") 
		unless $boundary;
		$boundary =  "--" . $boundary;
		$blen = length ($boundary);
		if ($ENV{'REQUEST_METHOD'} ne 'POST') {
			&clform_CgiDie("Invalid request method for  multipart/form-data: $meth\n");
		}
		if ($writefiles) {
			my ($me);
			stat ($writefiles);
			$writefiles = "/tmp" unless  -d _ && -w _;
			# ($me) = $0 =~ m#([^/]*)$#;
			$writefiles .= "/$aFilePre"; 
		}
		$left = $len;
		PART: # find each part of the multi-part while reading data
		while (1) {
			die $@ if $errflag;
			$amt = ($left > $bufsize + $maxbound - length($buf) ?  $bufsize + $maxbound - length($buf): $left);
			$errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
			die "Short Read: wanted $amt, got $got\n" if $errflag;
			$left -= $amt;
			$in{$name} .= "\0" if defined $in{$name}; 
			$in{$name} .= $fn if $fn;
			$name =~ /([-\w]+)/;  # This allows $insfn{$name} to be untainted
			if (defined $1) {
				$insfn{$1} .= "\0" if defined $insfn{$1}; 
				$insfn{$1} .= $fn if $fn;
			}
			BODY: 
			while (($bpos = index($buf, $boundary)) == -1) {
				if ($left == 0 && $buf eq '') {
					  foreach $value (values %insfn) {
						unlink(split("\0",$value));
					}
					&clform_CgiDie("clform: reached end of input while seeking boundary of multipart. Format of CGI input is wrong.\n");
				}
				die $@ if $errflag;
				if ($name) {  # if no $name, then it's the prologue -- discard
					if ($fn) {
						print FILE substr($buf, 0, $bufsize);
					} else {
						$in{$name} .= substr($buf, 0, $bufsize);
					}
				}
				$buf = substr($buf, $bufsize);
				$amt = ($left > $bufsize ? $bufsize : $left); # $maxbound == length($buf);
				$errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
				die "Short Read: wanted $amt, got $got\n" if $errflag;
				$left -= $amt;
			}
			if (defined $name) {  # if no $name, then it's the prologue -- discard
				if ($fn) {
					print FILE substr($buf, 0, $bpos - 2);
				} else {
					$in {$name} .= substr($buf, 0, $bpos - 2); # kill last \r\n
				}
			}
			close (FILE);
			last PART if substr($buf, $bpos + $blen, 2) eq "--";
			substr($buf, 0, $bpos + $blen + 2) = '';
			$amt = ($left > $bufsize + $maxbound - length($buf) ? $bufsize + $maxbound - length($buf) : $left);
			$errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
			die "Short Read: wanted $amt, got $got\n" if $errflag;
			$left -= $amt;
			undef $head;
			undef $fn;
			HEAD:
			while (($lpos = index($buf, "\r\n\r\n")) == -1) { 
				if ($left == 0  && $buf eq '') {
					foreach $value (values %insfn) {
						unlink(split("\0",$value));
					}
					&clform_CgiDie("cgi-lib: reached end of input while seeking end of headers. Format of CGI input is wrong.\n$buf");
				}
				die $@ if $errflag;
				$head .= substr($buf, 0, $bufsize);
				$buf = substr($buf, $bufsize);
				$amt = ($left > $bufsize ? $bufsize : $left); # $maxbound == length($buf);
				$errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
				die "Short Read: wanted $amt, got $got\n" if $errflag;
				$left -= $amt;
			}
			$head .= substr($buf, 0, $lpos + 2);
			push (@in, $head);
			@heads = split("\r\n", $head);
			($cd) = grep (/^\s*Content-Disposition:/i, @heads);
			($ct) = grep (/^\s*Content-Type:/i, @heads);
			($name) = $cd =~ /\bname="([^"]+)"/i; #"; 
			($name) = $cd =~ /\bname=([^\s:;]+)/i unless defined $name;  
			($fname) = $cd =~ /\bfilename="([^"]*)"/i; #"; # filename can be null-str
			($fname) = $cd =~ /\bfilename=([^\s:;]+)/i unless defined $fname;
			$incfn{$name} .= (defined $in{$name} ? "\0" : "") . 
			(defined $fname ? $fname : "");
			($ctype) = $ct =~ /^\s*Content-type:\s*"([^"]+)"/i;  #";
			($ctype) = $ct =~ /^\s*Content-Type:\s*([^\s:;]+)/i unless defined $ctype;
			$inct{$name} .= (defined $in{$name} ? "\0" : "") . $ctype;
			if ($writefiles && defined $fname) {
				$ser++;
				$fn = $writefiles . ".$$.$ser";
				open (FILE, ">$fn") || &clform_CgiDie("Couldn't open $fn\n");
				binmode (FILE);  # write files accurately
			}
			substr($buf, 0, $lpos + 4) = '';
			undef $fname;
			undef $ctype;
		}
		1;
END_MULTIPART
		if ($errflag) {
			my ($errmsg, $value);
			$errmsg = $@ || $errflag;
			foreach $value (values %insfn) {
				unlink(split("\0",$value));
			}
			&clform_CgiDie($errmsg);
		} else {
			# everything's ok.
		}
	} elsif ($type eq 'text/xml' and $meth eq 'POST') { # XML-RPC interface
		my $body = '';
		my $got = read(STDIN, $body, $len);
		&clform_CgiDie("clform : [short read]wanted $len, got $got\n") if ($got != $len);
		$body = &sbtxt_linefeed($body);
		$in{'charset'} = $2 if ($body =~ /^<\?xml(.*?)encoding=\"(.*?)\"(.*?)>/s);
		$in{'methodName'} = $1 if ($body =~ /<methodName>(.*?)<\/methodName>/is);
		$in{'params'} = $1 if ($body =~ /<params>(.*?)<\/params>/is);
		$gEnv{'admn'}{'xmlrpc'} = 1;
	} else {
		&clform_CgiDie("clform: Unknown Content-type: $ENV{'CONTENT_TYPE'}\n");
	}
	# no-ops to avoid warnings
	$insfn = $insfn;
	$incfn = $incfn;
	$inct  = $inct;
	$^W = $perlwarn;
	return ($errflag ? undef :  scalar(@in)); 
}

sub clform_CgiDie { # from cgi-lib.pl 2.18 / Copyright (c) 1993-1999 Steven E. Brenner
	my (@msg) = @_;
	print 'Content-Type: text/html' . "\n\n";
	print "<html>\n<head>\n<title>$msg[0]</title>\n</head>\n<body>\n";
	print "<h1>$msg[0]</h1>\n";
	foreach $i (1 .. $#msg) {
		print "<p>$msg[$i]</p>\n";
	}
	die @msg;
}
1;
